#include <ncbi.h>
#include <gishlib.h>
#include "blastapp.h"

void
pvals_x(hlp, tlen, dblen)
	HitListPtr	hlp;
	unsigned long	tlen;
	unsigned long	dblen;
{
	register HSPPtr	hp, minhp;
	register double	p;
	double	xtlen = tlen;
	double	xdblen = dblen;
	Score_t	highscore = SCORE_MIN, scoreray[3];
	register int	frame;
	int		sgn;
	double	x;
	seq_data	PNTR sdp;

	scoreray[0] = scoreray[1] = scoreray[2] = 0;
	for (hp=minhp= hlp->hp; hp != NULL; hp = hp->next) {
		frame = hp->frame;
		sgn = SIGN(frame) + 1;
		scoreray[sgn] += hp->score;

		if (frame > 0)
			--frame;
		else
			frame = 2 - frame;
		sdp = &sd[frame];
		if (hp->score > highscore)
			highscore = hp->score;
		x = stoe(hp->score, sdp->Lambda, sdp->K, sdp->H, tlen, sdp->efflen);
		p = etopoissonp(hp->n, x);
		p = gapdecay(hp->n, p, gapdecayrate);

		/*
		Calculate the p-value adjusted for the length of the database
		sequence versus the total length of the database
		*/
		hp->P_val = etop(hp->expect = (p * xdblen)/xtlen);

		/* Remember which HSP had the smallest Poisson probability */
		if (hp->expect < minhp->expect)
			minhp = hp;
	}
	hlp->signifhsp = minhp;
	hlp->highscore = highscore;
	hlp->totalscore = MAX(scoreray[0], MAX(scoreray[1], scoreray[2]));
}


void
consist_pvals_x(hlp, tlen, dblen)
	HitListPtr	hlp;
	unsigned long	tlen;
	unsigned long	dblen;
{
	register HSPPtr	hp, minhp;
	register double	p;
	double	xtlen = tlen;
	double	xdblen = dblen;
	Score_t	highscore = SCORE_MIN, scoreray[3];
	register int	frame;
	int		sgn;
	double	x;
	seq_data	PNTR sdp;

	scoreray[0] = scoreray[1] = scoreray[2] = 0;
	for (hp=minhp= hlp->hp; hp != NULL; hp = hp->next) {
		frame = hp->frame;
		sgn = SIGN(frame) + 1;
		scoreray[sgn] += hp->score;

		if (frame > 0)
			--frame;
		else
			frame = 2 - frame;
		sdp = &sd[frame];
		if (hp->score > highscore)
			highscore = hp->score;
		x = stoe(hp->score, sdp->Lambda, sdp->K, sdp->H, tlen, sdp->efflen);
		p = etoconsistp(hp->n, x);
		p = gapdecay(hp->n, p, gapdecayrate);

		/*
		Calculate the p-value adjusted for the length of the database
		sequence versus the total length of the database
		*/
		hp->P_val = etop(hp->expect = (p * xdblen)/xtlen);

		/* Remember which HSP had the smallest Poisson probability */
		if (hp->expect < minhp->expect)
			minhp = hp;
	}
	hlp->signifhsp = minhp;
	hlp->highscore = highscore;
	hlp->totalscore = MAX(scoreray[0], MAX(scoreray[1], scoreray[2]));
}
